/* tslint:disable */
/* eslint-disable */
/**
 * Coscine Web API
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, type RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../../base';
// @ts-ignore
import type { HandleDtoResponse } from '../../@coscine/model';
// @ts-ignore
import type { HandleForUpdateDto } from '../../@coscine/model';
/**
 * HandleApi - axios parameter creator
 * @export
 */
export const HandleApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2HandlesOptions: async (options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/handles`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'OPTIONS', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves all values of a handle by its PID.
         * @param {string} prefix The prefix of the PID
         * @param {string} suffix The suffix of the PID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getHandle: async (prefix: string, suffix: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'prefix' is not null or undefined
            assertParamExists('getHandle', 'prefix', prefix)
            // verify required parameter 'suffix' is not null or undefined
            assertParamExists('getHandle', 'suffix', suffix)
            const localVarPath = `/api/v2/handles/{prefix}/{suffix}`
                .replace(`{${"prefix"}}`, encodeURIComponent(String(prefix)))
                .replace(`{${"suffix"}}`, encodeURIComponent(String(suffix)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Updates a handle.
         * @param {string} prefix The prefix of the PID
         * @param {string} suffix The suffix of the PID
         * @param {HandleForUpdateDto} [handleForUpdateDto] The handle for updating.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateHandle: async (prefix: string, suffix: string, handleForUpdateDto?: HandleForUpdateDto, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'prefix' is not null or undefined
            assertParamExists('updateHandle', 'prefix', prefix)
            // verify required parameter 'suffix' is not null or undefined
            assertParamExists('updateHandle', 'suffix', suffix)
            const localVarPath = `/api/v2/handles/{prefix}/{suffix}`
                .replace(`{${"prefix"}}`, encodeURIComponent(String(prefix)))
                .replace(`{${"suffix"}}`, encodeURIComponent(String(suffix)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(handleForUpdateDto, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * HandleApi - functional programming interface
 * @export
 */
export const HandleApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = HandleApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV2HandlesOptions(options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV2HandlesOptions(options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['HandleApi.apiV2HandlesOptions']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves all values of a handle by its PID.
         * @param {string} prefix The prefix of the PID
         * @param {string} suffix The suffix of the PID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getHandle(prefix: string, suffix: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HandleDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getHandle(prefix, suffix, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['HandleApi.getHandle']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Updates a handle.
         * @param {string} prefix The prefix of the PID
         * @param {string} suffix The suffix of the PID
         * @param {HandleForUpdateDto} [handleForUpdateDto] The handle for updating.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async updateHandle(prefix: string, suffix: string, handleForUpdateDto?: HandleForUpdateDto, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.updateHandle(prefix, suffix, handleForUpdateDto, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['HandleApi.updateHandle']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * HandleApi - factory interface
 * @export
 */
export const HandleApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = HandleApiFp(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2HandlesOptions(options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.apiV2HandlesOptions(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves all values of a handle by its PID.
         * @param {HandleApiGetHandleRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getHandle(requestParameters: HandleApiGetHandleRequest, options?: RawAxiosRequestConfig): AxiosPromise<HandleDtoResponse> {
            return localVarFp.getHandle(requestParameters.prefix, requestParameters.suffix, options).then((request) => request(axios, basePath));
        },
        /**
         * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
         * @summary Updates a handle.
         * @param {HandleApiUpdateHandleRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateHandle(requestParameters: HandleApiUpdateHandleRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.updateHandle(requestParameters.prefix, requestParameters.suffix, requestParameters.handleForUpdateDto, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for getHandle operation in HandleApi.
 * @export
 * @interface HandleApiGetHandleRequest
 */
export interface HandleApiGetHandleRequest {
    /**
     * The prefix of the PID
     * @type {string}
     * @memberof HandleApiGetHandle
     */
    readonly prefix: string

    /**
     * The suffix of the PID
     * @type {string}
     * @memberof HandleApiGetHandle
     */
    readonly suffix: string
}

/**
 * Request parameters for updateHandle operation in HandleApi.
 * @export
 * @interface HandleApiUpdateHandleRequest
 */
export interface HandleApiUpdateHandleRequest {
    /**
     * The prefix of the PID
     * @type {string}
     * @memberof HandleApiUpdateHandle
     */
    readonly prefix: string

    /**
     * The suffix of the PID
     * @type {string}
     * @memberof HandleApiUpdateHandle
     */
    readonly suffix: string

    /**
     * The handle for updating.
     * @type {HandleForUpdateDto}
     * @memberof HandleApiUpdateHandle
     */
    readonly handleForUpdateDto?: HandleForUpdateDto
}

/**
 * HandleApi - object-oriented interface
 * @export
 * @class HandleApi
 * @extends {BaseAPI}
 */
export class HandleApi extends BaseAPI {
    /**
     * 
     * @summary Responds with the HTTP methods allowed for the endpoint.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HandleApi
     */
    public apiV2HandlesOptions(options?: RawAxiosRequestConfig) {
        return HandleApiFp(this.configuration).apiV2HandlesOptions(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves all values of a handle by its PID.
     * @param {HandleApiGetHandleRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HandleApi
     */
    public getHandle(requestParameters: HandleApiGetHandleRequest, options?: RawAxiosRequestConfig) {
        return HandleApiFp(this.configuration).getHandle(requestParameters.prefix, requestParameters.suffix, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * <p><strong>Required JWT roles for access:</strong> <code>administrator</code>.</p>
     * @summary Updates a handle.
     * @param {HandleApiUpdateHandleRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HandleApi
     */
    public updateHandle(requestParameters: HandleApiUpdateHandleRequest, options?: RawAxiosRequestConfig) {
        return HandleApiFp(this.configuration).updateHandle(requestParameters.prefix, requestParameters.suffix, requestParameters.handleForUpdateDto, options).then((request) => request(this.axios, this.basePath));
    }
}

